﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Data;

namespace FirstWPFApp
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        #region Declarations
        MyClass mc = new MyClass();
        #endregion

        #region Methods
        public MainWindow()
        {
            InitializeComponent();
            ViewEntries();
            stkSuccess.Visibility = Visibility.Hidden;
        }
        private void ViewEntries()
        {
            IList<MyClass> entries=MyClass.ViewEntries();
            lstViewEntries.DataContext = entries;
        }
        private void btnSubmit_Click(object sender, RoutedEventArgs e)
        {
            mc.fname = txtFName.Text;
            mc.lname = txtLName.Text;
            mc.email = txtEmail.Text;
            mc.likewpf = Convert.ToBoolean(chkLikeWpf.IsChecked);
            mc.Insert();
            if (mc.error != null)
            {
                Error errWin = new Error();
                errWin.txtBlkError.Text = mc.error.ToString();
                errWin.ShowDialog();
            }
            txtFName.Text = "";
            txtLName.Text = "";
            txtEmail.Text = "";
            chkLikeWpf.IsChecked = false;
            stkSuccess.Visibility = Visibility.Visible;
            ViewEntries();
        }

        private void btnReset_Click(object sender, RoutedEventArgs e)
        {
            txtFName.Text = "";
            txtLName.Text = "";
            txtEmail.Text = "";
            chkLikeWpf.IsChecked = false;
        }
        private void mnuExit_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
        private void mnuEdit_Click(object sender, RoutedEventArgs e)
        {
            EditEntry editWin = new EditEntry();
            editWin.ShowDialog();
            ViewEntries();
        }
        private void mnuDelete_Click(object sender, RoutedEventArgs e)
        {
            DeleteEntry deleteWin = new DeleteEntry();
            deleteWin.ShowDialog();
            ViewEntries();
        }
        #endregion
    }
}
