﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
namespace FirstWPFApp
{
    class MyClass
    {
        #region Declarations
        public int id { get; set; }
        public string fname { get; set; }
        public string lname { get; set; }
        public string email { get; set; }
        public bool likewpf { get; set; }
        public string error { get; set; }
        #endregion

        #region Methods
        public void Insert()
        {
            SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["connString"]);
            SqlCommand cmd = new SqlCommand("spWPFInsert",conn);
            cmd.CommandType = CommandType.StoredProcedure;
            SqlParameter parameterFName = new SqlParameter("@FName", SqlDbType.VarChar, 50);
            SqlParameter parameterLName = new SqlParameter("@LName", SqlDbType.VarChar, 50);
            SqlParameter parameterEmail = new SqlParameter("@Email", SqlDbType.VarChar, 50);
            SqlParameter parameterLikeWPF = new SqlParameter("@LikeWPF", SqlDbType.Bit);
            parameterFName.Value = fname;
            parameterLName.Value = lname;
            parameterEmail.Value = email;
            parameterLikeWPF.Value = likewpf;
            cmd.Parameters.Add(parameterFName);
            cmd.Parameters.Add(parameterLName);
            cmd.Parameters.Add(parameterEmail);
            cmd.Parameters.Add(parameterLikeWPF);
            try
            {
                conn.Open();
                cmd.ExecuteNonQuery();
            }
            catch (Exception ex)
            {
                error = ex.ToString();
            }
            finally
            {
                cmd.Dispose();
                conn.Close();
            }
        }
        public static IList<MyClass> ViewEntries()
        {
            SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["connString"]);
            SqlCommand cmd = new SqlCommand("spWPFListView", conn);
            cmd.CommandType = CommandType.StoredProcedure;
            List<MyClass> entries = new List<MyClass>();
            try
            {
                conn.Open();
                SqlDataReader dr = cmd.ExecuteReader();
                while (dr.Read())
                {
                    MyClass mc = new MyClass();
                    mc.id = Convert.ToInt32(dr["ID"]);
                    mc.fname = dr["FName"].ToString();
                    mc.lname = dr["LName"].ToString();
                    mc.email = dr["Email"].ToString();
                    mc.likewpf = Convert.ToBoolean(dr["LikeWPF"]);
                    entries.Add(mc);
                }
            }
            catch
            {
               
            }
            finally
            {
                cmd.Dispose();
                conn.Close();
            }
            return entries;
        }

        public void Update()
        {
            SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["connString"]);
            SqlCommand cmd = new SqlCommand("spWPFUpdate", conn);
            cmd.CommandType = CommandType.StoredProcedure;
            SqlParameter parameterFName = new SqlParameter("@FName", SqlDbType.VarChar, 50);
            SqlParameter parameterLName = new SqlParameter("@LName", SqlDbType.VarChar, 50);
            SqlParameter parameterEmail = new SqlParameter("@Email", SqlDbType.VarChar, 50);
            SqlParameter parameterLikeWPF = new SqlParameter("@LikeWPF", SqlDbType.Bit);
            SqlParameter parameterID = new SqlParameter("@ID", SqlDbType.Int);
            parameterFName.Value = fname;
            parameterLName.Value = lname;
            parameterEmail.Value = email;
            parameterLikeWPF.Value = likewpf;
            parameterID.Value = id;
            cmd.Parameters.Add(parameterFName);
            cmd.Parameters.Add(parameterLName);
            cmd.Parameters.Add(parameterEmail);
            cmd.Parameters.Add(parameterLikeWPF);
            cmd.Parameters.Add(parameterID);
            try
            {
                conn.Open();
                cmd.ExecuteNonQuery();
            }
            catch (Exception ex)
            {
                error = ex.ToString();
            }
            finally
            {
                cmd.Dispose();
                conn.Close();
            }
        }
        public int ViewEntry(int ID)
        {
            SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["connString"]);
            SqlCommand cmd = new SqlCommand("spWPFViewEntry", conn);
            cmd.CommandType = CommandType.StoredProcedure;
            SqlParameter parameterID = new SqlParameter("@ID", SqlDbType.Int);
            parameterID.Value = ID;
            cmd.Parameters.Add(parameterID);
            try
            {
                conn.Open();
                SqlDataReader dr = cmd.ExecuteReader();
                if (dr.Read())
                {
                    fname = dr["FName"].ToString();
                    lname = dr["LName"].ToString();
                    email = dr["Email"].ToString();
                    likewpf = Convert.ToBoolean(dr["LikeWPF"]);
                }
            }
            catch (Exception ex)
            {
                error = ex.ToString();
            }
            finally
            {
                cmd.Dispose();
                conn.Close();
            }
            return ID;
        }
        public void Delete()
        {
            SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["connString"]);
            SqlCommand cmd = new SqlCommand("spWPFDelete", conn);
            cmd.CommandType = CommandType.StoredProcedure;
            SqlParameter parameterID = new SqlParameter("@ID", SqlDbType.Int);
            parameterID.Value = id;
            cmd.Parameters.Add(parameterID);
            try
            {
                conn.Open();
                cmd.ExecuteNonQuery();
            }
            catch (Exception ex)
            {
                error = ex.ToString();
            }
            finally
            {
                cmd.Dispose();
                conn.Close();
            }
        }
        #endregion
    }
}